﻿Imports System.Data.SQLite
Imports Telerik.WinControls
Imports Telerik.WinControls.UI

Public Class RadFormInsert
    Dim Stoperica As New Stopwatch

    Dim newRow As GridViewDataRowInfo

    Dim CitaPodatke As SQLiteDataReader
    Dim CMD As New SQLiteCommand
    Dim CN As New SQLiteConnection(System.Configuration.ConfigurationManager.ConnectionStrings("TimeTracking.My.MySettings.timetrackingConnectionString").ConnectionString)

    Dim ObavezaDatumPocetak, ObavezaDatumKraj As String

    Dim NoviUlaz As Boolean
    Dim IzvrsavaPodatke As Integer
    Dim UradjenoID As Integer
    Dim PoslednjiZapis As Integer

    Private Sub RadFormInsert_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.EmployerTableAdapter.Fill(Me.TimeTrackingDataSet.employer)
        Me.JobTableAdapter.Fill(Me.TimeTrackingDataSet.job)
        Me.PersonTableAdapter.Fill(Me.TimeTrackingDataSet.person)
        Me.CustomerTableAdapter.Fill(Me.TimeTrackingDataSet.customer)
        Me.WorkTableAdapter.FillBySum(Me.TimeTrackingDataSet.work)

        Me.Text = My.Resources.TimeTracking.Activity

        CommandBarButton1.Text = My.Resources.TimeTracking.Customer
        CommandBarButton2.Text = My.Resources.TimeTracking.Employer
        CommandBarButton3.Text = My.Resources.TimeTracking.Job
        CommandBarButton4.Text = My.Resources.TimeTracking.Print
        PersonCommandBarButton.Text = My.Resources.TimeTracking.Person
        CompanyCommandBarButton.Text = My.Resources.TimeTracking.Company

        StartRadButton.Text = My.Resources.TimeTracking.Start
        EndRadButton.Text = My.Resources.TimeTracking.EndofTime
        ManualTimeRadButton.Text = My.Resources.TimeTracking.EnterData
        DeleteRadButton.Text = My.Resources.TimeTracking.Delete
        RadLabel2.Text = My.Resources.TimeTracking.EndofTime
        RadLabel1.Text = My.Resources.TimeTracking.Start
        RadGroupBox1.Text = My.Resources.TimeTracking.EnterData
        RadLabel3.Text = My.Resources.TimeTracking.Other
        DescRadTextBox.NullText = My.Resources.TimeTracking.Description
        PersonRadDropDownList.NullText = My.Resources.TimeTracking.Person
        CustomerRadDropDownList.NullText = My.Resources.TimeTracking.Customer
        EmployerRadDropDownList.NullText = My.Resources.TimeTracking.Employer
        JobRadDropDownList.NullText = My.Resources.TimeTracking.Job

        StartDateDateTimePicker.Value = Now
        EndDateDateTimePicker.Value = Now
        StartTimeTimePicker.Value = Now.ToShortTimeString
        EndTimeTimePicker.Value = Now.ToShortTimeString

        ObavezaDatumPocetak = StartDateDateTimePicker.Value.Date + " " + StartTimeTimePicker.Value
        ObavezaDatumKraj = EndDateDateTimePicker.Value.Date + " " + EndTimeTimePicker.Value

        NoviUlaz = True
        PoslednjiZapis = 0

        PersonRadDropDownList.Text = String.Empty
        CustomerRadDropDownList.Text = String.Empty
        EmployerRadDropDownList.Text = String.Empty
        JobRadDropDownList.Text = String.Empty
        StopwatchRadLabel.Text = "00:00:00"

        Me.Show()
        DescRadTextBox.Focus()
        PersonRadDropDownList.Focus()

        EndRadButton.Enabled = False

    End Sub

    Private Sub PocetakRadButton_Click(sender As Object, e As EventArgs) Handles StartRadButton.Click
        StopwatchRadLabel.Text = "00:00:00"
        Me.Stoperica.Reset()
        Timer1.Start()
        Me.Stoperica.Start()

        If NoviUlaz = True And PoslednjiZapis = 0 Then

            ManualTimeRadButton.Enabled = False
            EndRadButton.Enabled = True
            StartRadButton.Enabled = False

            Dim CMD1 As New SQLiteCommand
            Dim CN1 As New SQLiteConnection(System.Configuration.ConfigurationManager.ConnectionStrings("TimeTracking.My.MySettings.timetrackingConnectionString").ConnectionString)
            CMD1.Connection = CN1
            Dim timestamp As Long = GetTimestampUtc()
            CMD1.CommandText = "INSERT INTO work (customer_id,employer_id,person_id,job_id,description,workstart,workend,price) VALUES (@customer_id,@employer_id,@person_id,@job_id,@description,@workstart,@workend,@price);select last_insert_rowid()"
            CMD1.Parameters.AddWithValue("@customer_id", CustomerRadDropDownList.SelectedValue)
            CMD1.Parameters.AddWithValue("@employer_id", EmployerRadDropDownList.SelectedValue)
            CMD1.Parameters.AddWithValue("@person_id", PersonRadDropDownList.SelectedValue)
            CMD1.Parameters.AddWithValue("@job_id", JobRadDropDownList.SelectedValue)
            CMD1.Parameters.AddWithValue("@description", DescRadTextBox.Text)

            ObavezaDatumPocetak = Now
            CMD1.Parameters.AddWithValue("@workstart", GetTimestampUtc(ObavezaDatumPocetak))
            CMD1.Parameters.AddWithValue("@workend", GetTimestampUtc(ObavezaDatumPocetak))
            CMD1.Parameters.AddWithValue("@price", CLng(ExpenseCenaRadMaskedEditBox.Text))

            CMD1.Connection.Open()
            PoslednjiZapis = CMD1.ExecuteScalar()

            If CN1.State = ConnectionState.Open Then
                CN1.Close()
                CMD1.Dispose()
                CN1.Dispose()
            End If
            Me.WorkTableAdapter.FillBySum(Me.TimeTrackingDataSet.work)
        Else
            RadMessageBox.SetThemeName("VisualStudio2012Light")
            RadMessageBox.Show(Me, "Timer has already started", "Warning", MessageBoxButtons.OK, RadMessageIcon.Exclamation, MessageBoxDefaultButton.Button1)
        End If

    End Sub

    Private Sub KrajRadButton_Click(sender As Object, e As EventArgs) Handles EndRadButton.Click
        Timer1.Stop()
        Me.Stoperica.Stop()

        If NoviUlaz = True And PoslednjiZapis > 0 Then

            Dim CMD1 As New SQLiteCommand
            Dim CN1 As New SQLiteConnection(System.Configuration.ConfigurationManager.ConnectionStrings("TimeTracking.My.MySettings.timetrackingConnectionString").ConnectionString)
            CMD1.Connection = CN1
            Dim timestamp As Long = GetTimestampUtc()
            CMD1.CommandText = "UPDATE work set customer_id=@customer_id,employer_id=@employer_id,person_id=@person_id,job_id=@job_id,description=@description,workend=@workend,price=@price WHERE _id=@id"
            CMD1.Parameters.AddWithValue("@id", PoslednjiZapis)
            CMD1.Parameters.AddWithValue("@customer_id", CustomerRadDropDownList.SelectedValue)
            CMD1.Parameters.AddWithValue("@employer_id", EmployerRadDropDownList.SelectedValue)
            CMD1.Parameters.AddWithValue("@person_id", PersonRadDropDownList.SelectedValue)
            CMD1.Parameters.AddWithValue("@job_id", JobRadDropDownList.SelectedValue)
            CMD1.Parameters.AddWithValue("@description", DescRadTextBox.Text)
            ObavezaDatumKraj = Now
            CMD1.Parameters.AddWithValue("@workend", GetTimestampUtc(ObavezaDatumKraj))
            CMD1.Parameters.AddWithValue("@price", CLng(ExpenseCenaRadMaskedEditBox.Text))

            CMD1.Connection.Open()
            CMD1.ExecuteNonQuery()

            If CN1.State = ConnectionState.Open Then
                CN1.Close()
                CMD1.Dispose()
                CN1.Dispose()
            End If

            NoviUlaz = True
            PoslednjiZapis = 0

            StartRadButton.Enabled = True
            EndRadButton.Enabled = False
            ManualTimeRadButton.Enabled = True

            Me.WorkTableAdapter.FillBySum(Me.TimeTrackingDataSet.work)
        Else
            RadMessageBox.SetThemeName("VisualStudio2012Light")
            RadMessageBox.Show(Me, "End time is for new entry", "Warning", MessageBoxButtons.OK, RadMessageIcon.Exclamation, MessageBoxDefaultButton.Button1)
        End If
    End Sub

    Private Function GetTimestampUtc(Optional ByVal ofSpecificDatetime As DateTime = Nothing) As Long
        If ofSpecificDatetime = Nothing Then
            Return Convert.ToInt64(DateTime.UtcNow.Subtract(#1/1/1970#).TotalSeconds)
        Else
            'Return Convert.ToInt64(ofSpecificDatetime.ToUniversalTime.Subtract(#1/1/1970#).TotalSeconds) 'univerzalno vreme bez obzira na zonu
            Return Convert.ToInt64(ofSpecificDatetime.Subtract(#1/1/1970#).TotalSeconds)
        End If
    End Function

    Public Function UnixTimestampToDateTime(ByVal unixTimeStamp As Integer) As DateTime
        Return (New DateTime(1970, 1, 1, 0, 0, 0)).AddSeconds(unixTimeStamp)
    End Function

    Private Sub VremeRadButton_Click(sender As Object, e As EventArgs) Handles ManualTimeRadButton.Click
        Try
            If NoviUlaz = False And PoslednjiZapis > 0 Then

                Dim CMD1 As New SQLiteCommand
                Dim CN1 As New SQLiteConnection(System.Configuration.ConfigurationManager.ConnectionStrings("TimeTracking.My.MySettings.timetrackingConnectionString").ConnectionString)
                CMD1.Connection = CN1
                Dim timestamp As Long = GetTimestampUtc()
                CMD1.CommandText = "UPDATE work set customer_id=@customer_id,employer_id=@employer_id,person_id=@person_id,job_id=@job_id,description=@description,workend=@workend,price=@price WHERE _id=@id"
                CMD1.Parameters.AddWithValue("@id", PoslednjiZapis)
                CMD1.Parameters.AddWithValue("@customer_id", CustomerRadDropDownList.SelectedValue)
                CMD1.Parameters.AddWithValue("@employer_id", EmployerRadDropDownList.SelectedValue)
                CMD1.Parameters.AddWithValue("@person_id", PersonRadDropDownList.SelectedValue)
                CMD1.Parameters.AddWithValue("@job_id", JobRadDropDownList.SelectedValue)
                CMD1.Parameters.AddWithValue("@description", DescRadTextBox.Text)
                ObavezaDatumPocetak = StartDateDateTimePicker.Value.Date + " " + StartTimeTimePicker.Value
                ObavezaDatumKraj = EndDateDateTimePicker.Value.Date + " " + EndTimeTimePicker.Value
                CMD1.Parameters.AddWithValue("@workstart", GetTimestampUtc(ObavezaDatumPocetak))
                CMD1.Parameters.AddWithValue("@workend", GetTimestampUtc(ObavezaDatumKraj))
                CMD1.Parameters.AddWithValue("@price", CLng(ExpenseCenaRadMaskedEditBox.Text))

                CMD1.Connection.Open()
                CMD1.ExecuteNonQuery()

                If CN1.State = ConnectionState.Open Then
                    CN1.Close()
                    CMD1.Dispose()
                    CN1.Dispose()
                End If

                NoviUlaz = True
                PoslednjiZapis = 0
                StartRadButton.Enabled = True
                EndRadButton.Enabled = True
                ManualTimeRadButton.Text = My.Resources.TimeTracking.EnterData
                CustomerRadDropDownList.SelectedIndex = -1
                EmployerRadDropDownList.SelectedIndex = -1
                PersonRadDropDownList.SelectedIndex = -1
                JobRadDropDownList.SelectedIndex = -1

                DescRadTextBox.Text = ""
                ExpenseCenaRadMaskedEditBox.Text = 0

                StartDateDateTimePicker.Value = Now
                EndDateDateTimePicker.Value = Now
                StartTimeTimePicker.Value = Now.ToShortTimeString
                EndTimeTimePicker.Value = Now.ToShortTimeString

                Me.WorkTableAdapter.FillBySum(Me.TimeTrackingDataSet.work)

                PersonRadDropDownList.Text = String.Empty
                CustomerRadDropDownList.Text = String.Empty
                EmployerRadDropDownList.Text = String.Empty
                JobRadDropDownList.Text = String.Empty
                StopwatchRadLabel.Text = "00:00:00"

                Me.Show()
                DescRadTextBox.Focus()
                PersonRadDropDownList.Focus()

                Exit Sub
            End If


            If NoviUlaz = True And PoslednjiZapis = 0 Then
                Dim CMD1 As New SQLiteCommand
                Dim CN1 As New SQLiteConnection(System.Configuration.ConfigurationManager.ConnectionStrings("TimeTracking.My.MySettings.timetrackingConnectionString").ConnectionString)
                CMD1.Connection = CN1
                Dim timestamp As Long = GetTimestampUtc()
                CMD1.CommandText = "INSERT INTO work (customer_id,employer_id,person_id,job_id,description,workstart,workend,price) VALUES (@customer_id,@employer_id,@person_id,@job_id,@description,@workstart,@workend,@price)"
                CMD1.Parameters.AddWithValue("@customer_id", CustomerRadDropDownList.SelectedValue)
                CMD1.Parameters.AddWithValue("@employer_id", EmployerRadDropDownList.SelectedValue)
                CMD1.Parameters.AddWithValue("@person_id", PersonRadDropDownList.SelectedValue)
                CMD1.Parameters.AddWithValue("@job_id", JobRadDropDownList.SelectedValue)
                CMD1.Parameters.AddWithValue("@description", DescRadTextBox.Text)
                ObavezaDatumPocetak = StartDateDateTimePicker.Value.Date + " " + StartTimeTimePicker.Value
                ObavezaDatumKraj = EndDateDateTimePicker.Value.Date + " " + EndTimeTimePicker.Value
                CMD1.Parameters.AddWithValue("@workstart", GetTimestampUtc(ObavezaDatumPocetak))
                CMD1.Parameters.AddWithValue("@workend", GetTimestampUtc(ObavezaDatumKraj))
                CMD1.Parameters.AddWithValue("@price", CLng(ExpenseCenaRadMaskedEditBox.Text))

                CMD1.Connection.Open()
                CMD1.ExecuteNonQuery()

                If CN1.State = ConnectionState.Open Then
                    CN1.Close()
                    CMD1.Dispose()
                    CN1.Dispose()
                End If


                NoviUlaz = True
                PoslednjiZapis = 0
                StartRadButton.Enabled = True
                EndRadButton.Enabled = True
                ManualTimeRadButton.Text = My.Resources.TimeTracking.EnterData
                CustomerRadDropDownList.SelectedIndex = -1
                EmployerRadDropDownList.SelectedIndex = -1
                PersonRadDropDownList.SelectedIndex = -1
                JobRadDropDownList.SelectedIndex = -1

                DescRadTextBox.Text = ""
                ExpenseCenaRadMaskedEditBox.Text = 0

                StartDateDateTimePicker.Value = Now
                EndDateDateTimePicker.Value = Now
                StartTimeTimePicker.Value = Now.ToShortTimeString
                EndTimeTimePicker.Value = Now.ToShortTimeString

                Me.WorkTableAdapter.FillBySum(Me.TimeTrackingDataSet.work)

                PersonRadDropDownList.Text = String.Empty
                CustomerRadDropDownList.Text = String.Empty
                EmployerRadDropDownList.Text = String.Empty
                JobRadDropDownList.Text = String.Empty
                StopwatchRadLabel.Text = "00:00:00"

                Me.Show()
                DescRadTextBox.Focus()
                PersonRadDropDownList.Focus()

            Else
                RadMessageBox.SetThemeName("VisualStudio2012Light")
                RadMessageBox.Show(Me, "Upisano počeno vreme. Potrebno je potvrditi završetak tasterom Kraj", "Warning", MessageBoxButtons.OK, RadMessageIcon.Exclamation, MessageBoxDefaultButton.Button1)
            End If
        Catch ex As Exception
            RadMessageBox.SetThemeName("VisualStudio2012Light")
            RadMessageBox.Show(Me, "Error" + vbCrLf + ex.ToString, "Warning", MessageBoxButtons.OK, RadMessageIcon.Exclamation, MessageBoxDefaultButton.Button1)
        End Try

    End Sub

    Private Sub RadGridView1_DoubleClick(sender As Object, e As EventArgs) Handles RadGridView1.DoubleClick
        Dim red As timetrackingDataSet.workRow
        red = CType(CType(Me.WorkBindingSource.Current, DataRowView).Row, timetrackingDataSet.workRow)

        Dim CMD1 As New SQLiteCommand
        Dim CN1 As New SQLiteConnection(System.Configuration.ConfigurationManager.ConnectionStrings("TimeTracking.My.MySettings.timetrackingConnectionString").ConnectionString)
        CMD1.Connection = CN1
        Dim timestamp As Long = GetTimestampUtc()
        CMD1.CommandText = "SELECT _id,customer_id,employer_id,person_id,job_id,description,price,workstart,workend FROM work  WHERE _id=@_id"
        CMD1.Parameters.AddWithValue("@_id", red._id)

        CMD1.Connection.Open()
        CitaPodatke = CMD1.ExecuteReader
        CitaPodatke.Read()

        CustomerRadDropDownList.SelectedValue = CitaPodatke("customer_id")
        EmployerRadDropDownList.SelectedValue = CitaPodatke("employer_id")
        PersonRadDropDownList.SelectedValue = CitaPodatke("person_id")
        JobRadDropDownList.SelectedValue = CitaPodatke("job_id")
        DescRadTextBox.Text = CitaPodatke("description").ToString
        ExpenseCenaRadMaskedEditBox.Text = CitaPodatke("price").ToString

        Try
            StartDateDateTimePicker.Value = UnixTimestampToDateTime(CitaPodatke("workstart"))
            EndDateDateTimePicker.Value = UnixTimestampToDateTime(CitaPodatke("workend"))
            StartTimeTimePicker.Value = UnixTimestampToDateTime(CitaPodatke("workstart")).ToShortTimeString
            EndTimeTimePicker.Value = UnixTimestampToDateTime(CitaPodatke("workend")).ToShortTimeString
        Catch ex As Exception

        End Try

        StartRadButton.Enabled = False
        EndRadButton.Enabled = False
        DeleteRadButton.Enabled = True
        ManualTimeRadButton.Text = My.Resources.TimeTracking.ChangeTme
        NoviUlaz = False
        PoslednjiZapis = CitaPodatke("_id")

        If CN1.State = ConnectionState.Open Then
            CitaPodatke.Close()
            CN1.Close()
            CMD1.Dispose()
            CN1.Dispose()
        End If

    End Sub

    Private Sub BrisanjeRadButton_Click(sender As Object, e As EventArgs) Handles DeleteRadButton.Click
        Dim CMD1 As New SQLiteCommand
        Dim CN1 As New SQLiteConnection(System.Configuration.ConfigurationManager.ConnectionStrings("TimeTracking.My.MySettings.timetrackingConnectionString").ConnectionString)
        CMD1.Connection = CN1
        Dim timestamp As Long = GetTimestampUtc()
        CMD1.CommandText = "DELETE FROM work WHERE _id=@id"
        CMD1.Parameters.AddWithValue("@id", PoslednjiZapis)

        CMD1.Connection.Open()
        CMD1.ExecuteNonQuery()

        If CN1.State = ConnectionState.Open Then
            CN1.Close()
            CMD1.Dispose()
            CN1.Dispose()
        End If

        NoviUlaz = True
        PoslednjiZapis = 0
        StartRadButton.Enabled = True
        EndRadButton.Enabled = True

        ManualTimeRadButton.Text = My.Resources.TimeTracking.EnterData

        CustomerRadDropDownList.SelectedIndex = -1
        EmployerRadDropDownList.SelectedIndex = -1
        PersonRadDropDownList.SelectedIndex = -1
        JobRadDropDownList.SelectedIndex = -1

        DescRadTextBox.Text = ""
        ExpenseCenaRadMaskedEditBox.Text = 0

        StartDateDateTimePicker.Value = Now
        EndDateDateTimePicker.Value = Now
        StartTimeTimePicker.Value = Now.ToShortTimeString
        EndTimeTimePicker.Value = Now.ToShortTimeString

        Me.WorkTableAdapter.FillBySum(Me.TimeTrackingDataSet.work)

        PersonRadDropDownList.Text = String.Empty
        CustomerRadDropDownList.Text = String.Empty
        EmployerRadDropDownList.Text = String.Empty
        JobRadDropDownList.Text = String.Empty
        StopwatchRadLabel.Text = "00:00:00"

        Me.Show()
        DescRadTextBox.Focus()
        PersonRadDropDownList.Focus()

        DeleteRadButton.Enabled = False
        ManualTimeRadButton.Enabled = True

    End Sub
    Private Sub PersonCommandBarButton_Click(sender As Object, e As EventArgs) Handles PersonCommandBarButton.Click
        RadFormPerson.ShowDialog()
        Me.PersonTableAdapter.Fill(Me.TimeTrackingDataSet.person)
    End Sub

    Private Sub CommandBarButton1_Click(sender As Object, e As EventArgs) Handles CommandBarButton1.Click
        RadFormCustomer.ShowDialog()
        Me.CustomerTableAdapter.Fill(Me.TimeTrackingDataSet.customer)
    End Sub

    Private Sub CommandBarButton2_Click(sender As Object, e As EventArgs) Handles CommandBarButton2.Click
        RadFormEmployer.ShowDialog()
        Me.EmployerTableAdapter.Fill(Me.TimeTrackingDataSet.employer)
    End Sub

    Private Sub CommandBarButton3_Click(sender As Object, e As EventArgs) Handles CommandBarButton3.Click
        RadFormJob.ShowDialog()
        Me.JobTableAdapter.Fill(Me.TimeTrackingDataSet.job)
    End Sub

    Private Sub CommandBarButton4_Click(sender As Object, e As EventArgs) Handles CommandBarButton4.Click
        RadFormPrint.ShowDialog()
    End Sub

    Private Sub CompanyCommandBarButton_Click(sender As Object, e As EventArgs) Handles CompanyCommandBarButton.Click
        RadFormCompany.ShowDialog()
    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim elapsed As TimeSpan = Me.Stoperica.Elapsed
        'StopericaRadLabel.Text = String.Format("{0:00}:{1:00}:{2:00}:{3:00}", Math.Floor(elapsed.TotalHours), elapsed.Minutes, elapsed.Seconds, elapsed.Milliseconds)
        StopwatchRadLabel.Text = String.Format("{0:00}:{1:00}:{2:00}", Math.Floor(elapsed.TotalHours), elapsed.Minutes, elapsed.Seconds)
    End Sub

    Private Sub RadGridView1_UserAddedRow(sender As Object, e As UI.GridViewRowEventArgs) Handles RadGridView1.UserAddedRow
        Me.Validate()
        Me.WorkBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.TimeTrackingDataSet)

        Dim DatumPocetak, DatumZavrsetak As Date

        DatumPocetak = newRow.Cells("datestart").Value
        DatumZavrsetak = newRow.Cells("dateEnd").Value
        PoslednjiZapis = e.Row.Cells("_id").Value

        Dim CMD1 As New SQLiteCommand
        Dim CN1 As New SQLiteConnection(System.Configuration.ConfigurationManager.ConnectionStrings("TimeTracking.My.MySettings.timetrackingConnectionString").ConnectionString)
        CMD1.Connection = CN1
        Dim timestamp As Long = GetTimestampUtc()
        CMD1.CommandText = "UPDATE work set workstart=@workstart,workend=@workend WHERE _id=@id"
        CMD1.Parameters.AddWithValue("@id", PoslednjiZapis)
        CMD1.Parameters.AddWithValue("@workstart", GetTimestampUtc(DatumPocetak))
        CMD1.Parameters.AddWithValue("@workend", GetTimestampUtc(DatumZavrsetak))

        CMD1.Connection.Open()
        CMD1.ExecuteNonQuery()

        If CN1.State = ConnectionState.Open Then
            CN1.Close()
            CMD1.Dispose()
            CN1.Dispose()
        End If

        Me.WorkTableAdapter.FillBySum(Me.TimeTrackingDataSet.work)

    End Sub
    Private Sub RadGridView1_UserDeletedRow(sender As Object, e As UI.GridViewRowEventArgs) Handles RadGridView1.UserDeletedRow
        Me.Validate()
        Me.WorkBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.TimeTrackingDataSet)

        Me.WorkTableAdapter.FillBySum(Me.TimeTrackingDataSet.work)
    End Sub

    Private Sub RadGridView1_RowsChanged(sender As Object, e As UI.GridViewCollectionChangedEventArgs) Handles RadGridView1.RowsChanged
        Me.Validate()
        Me.WorkBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.TimeTrackingDataSet)

        If e.Action = Telerik.WinControls.Data.NotifyCollectionChangedAction.Add Then
            Console.WriteLine("Row added")
        Else
            Console.WriteLine("Row NOT")

            Try
                newRow = TryCast(e.NewItems(0), GridViewDataRowInfo)

                Dim DatumPocetak, DatumZavrsetak As Date

                DatumPocetak = newRow.Cells("DateStart").Value
                DatumZavrsetak = newRow.Cells("DateEnd").Value
                PoslednjiZapis = newRow.Cells("_id").Value

                Dim CMD1 As New SQLiteCommand
                Dim CN1 As New SQLiteConnection(System.Configuration.ConfigurationManager.ConnectionStrings("TimeTracking.My.MySettings.timetrackingConnectionString").ConnectionString)
                CMD1.Connection = CN1
                Dim timestamp As Long = GetTimestampUtc()
                CMD1.CommandText = "UPDATE work set workstart=@workstart,workend=@workend WHERE _id=@id"
                CMD1.Parameters.AddWithValue("@id", PoslednjiZapis)
                CMD1.Parameters.AddWithValue("@workstart", GetTimestampUtc(DatumPocetak))
                CMD1.Parameters.AddWithValue("@workend", GetTimestampUtc(DatumZavrsetak))

                CMD1.Connection.Open()
                CMD1.ExecuteNonQuery()

                If CN1.State = ConnectionState.Open Then
                    CN1.Close()
                    CMD1.Dispose()
                    CN1.Dispose()
                End If

                Me.WorkTableAdapter.FillBySum(Me.TimeTrackingDataSet.work)

            Catch ex As Exception

            End Try

        End If
    End Sub

    Private Sub RadGridView1_DefaultValuesNeeded(ByVal sender As Object, ByVal e As GridViewRowEventArgs) Handles RadGridView1.DefaultValuesNeeded
        e.Row.Cells("price").Value = 0
    End Sub

End Class
