﻿Imports Telerik.Reporting
Imports Telerik.WinControls.UI

Public Class RadFormPrint
    Public radDateTimePicker1 As New RadDateTimePickerElement
    Public radDateTimePicker2 As New RadDateTimePickerElement

    Private Sub RadFormPrint_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.CustomerTableAdapter.Fill(Me.TimeTrackingDataSet.customer)
        
        FirmaCommandBarButton.Text = My.Resources.TimeTracking.TimeRecording
        FirmeCommandBarDropDownButton.Text = My.Resources.TimeTracking.Company
        RacunRadMenuItem.Text = My.Resources.TimeTracking.Company
        RadniSatiRadMenuItem.Text = My.Resources.TimeTracking.TimeRecording

        radDateTimePicker1.MinSize = New System.Drawing.Size(100, 0)
        CommandBarHostItem1.HostedItem = radDateTimePicker1
        radDateTimePicker1.Value = Now
        radDateTimePicker2.MinSize = New System.Drawing.Size(100, 0)
        CommandBarHostItem2.HostedItem = radDateTimePicker2
        radDateTimePicker2.Value = Now
        Me.Text = My.Resources.TimeTracking.Print
    End Sub

    Private Sub FirmaCommandBarButton_Click(sender As Object, e As EventArgs) Handles FirmaCommandBarButton.Click
        Dim red As timetrackingDataSet.customerRow
        red = CType(CType(Me.CustomerBindingSource.Current, DataRowView).Row, timetrackingDataSet.customerRow)
        Dim reportSource As New InstanceReportSource()
        reportSource.ReportDocument = New ReportJobDone
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("DateStart", GetTimestampUtc(radDateTimePicker1.Value.Value.Date + " " + "00:00:00")))
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("DateEnd", GetTimestampUtc(radDateTimePicker2.Value.Value.Date + " " + "23:59:59")))
        ReportViewer1.ReportSource = reportSource
        ReportViewer1.RefreshReport()
    End Sub
    Private Sub RacunRadMenuItem_Click(sender As Object, e As EventArgs) Handles RacunRadMenuItem.Click
        Dim red As timetrackingDataSet.customerRow
        red = CType(CType(Me.CustomerBindingSource.Current, DataRowView).Row, timetrackingDataSet.customerRow)
        Dim reportSource As New InstanceReportSource()
        reportSource.ReportDocument = New ReportInvoiceCompany
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("customerID", red._id))
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("customer", red.title))
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("DateStart", GetTimestampUtc(radDateTimePicker1.Value.Value.Date + " " + "00:00:00")))
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("DateEnd", GetTimestampUtc(radDateTimePicker2.Value.Value.Date + " " + "23:59:59")))
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("DateStartDate", radDateTimePicker1.Value))
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("DateEndDate", radDateTimePicker2.Value))
        ReportViewer1.ReportSource = reportSource
        ReportViewer1.RefreshReport()
    End Sub
    Private Sub RadniSatiRadMenuItem_Click(sender As Object, e As EventArgs) Handles RadniSatiRadMenuItem.Click
        Dim red As timetrackingDataSet.customerRow
        red = CType(CType(Me.CustomerBindingSource.Current, DataRowView).Row, timetrackingDataSet.customerRow)
        Dim reportSource As New InstanceReportSource()
        reportSource.ReportDocument = New ReportJobDoneCompany
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("customerID", red._id))
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("DateStart", GetTimestampUtc(radDateTimePicker1.Value.Value.Date + " " + "00:00:00")))
        reportSource.Parameters.Add(New Telerik.Reporting.Parameter("DateEnd", GetTimestampUtc(radDateTimePicker2.Value.Value.Date + " " + "23:59:59")))
        ReportViewer1.ReportSource = reportSource
        ReportViewer1.RefreshReport()
    End Sub
    Private Function GetTimestampUtc(Optional ByVal ofSpecificDatetime As DateTime = Nothing) As Long
        If ofSpecificDatetime = Nothing Then
            Return Convert.ToInt64(DateTime.UtcNow.Subtract(#1/1/1970#).TotalSeconds)
        Else
            'Return Convert.ToInt64(ofSpecificDatetime.ToUniversalTime.Subtract(#1/1/1970#).TotalSeconds) 'univerzalno vreme bez obzira na zonu
            Return Convert.ToInt64(ofSpecificDatetime.Subtract(#1/1/1970#).TotalSeconds)
        End If
    End Function
End Class
